diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/js/tinymce/themes/advanced/js/image.js ./wordpress-3.3/wp-includes/js/tinymce/themes/advanced/js/image.js
*** ./wordpress-3.2.1/wp-includes/js/tinymce/themes/advanced/js/image.js	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/js/tinymce/themes/advanced/js/image.js	2011-09-09 15:08:40.000000000 -0500
***************
*** 18,24 ****
  
  		e = ed.selection.getNode();
  
! 		this.fillFileList('image_list', 'tinyMCEImageList');
  
  		if (e.nodeName == 'IMG') {
  			f.src.value = ed.dom.getAttrib(e, 'src');
--- 18,24 ----
  
  		e = ed.selection.getNode();
  
! 		this.fillFileList('image_list', tinyMCEPopup.getParam('external_image_list', 'tinyMCEImageList'));
  
  		if (e.nodeName == 'IMG') {
  			f.src.value = ed.dom.getAttrib(e, 'src');
***************
*** 39,45 ****
  	fillFileList : function(id, l) {
  		var dom = tinyMCEPopup.dom, lst = dom.get(id), v, cl;
  
! 		l = window[l];
  
  		if (l && l.length > 0) {
  			lst.options[lst.options.length] = new Option('', '');
--- 39,45 ----
  	fillFileList : function(id, l) {
  		var dom = tinyMCEPopup.dom, lst = dom.get(id), v, cl;
  
! 		l = typeof(l) === 'function' ? l() : window[l];
  
  		if (l && l.length > 0) {
  			lst.options[lst.options.length] = new Option('', '');
***************
*** 80,87 ****
  			src : f.src.value.replace(/ /g, '%20'),
  			alt : f.alt.value,
  			width : f.width.value,
! 			height : f.height.value,
! 			'class' : f.class_name.value
  		});
  
  		el = ed.selection.getNode();
--- 80,86 ----
  			src : f.src.value.replace(/ /g, '%20'),
  			alt : f.alt.value,
  			width : f.width.value,
! 			height : f.height.value
  		});
  
  		el = ed.selection.getNode();
***************
*** 91,99 ****
  			tinyMCEPopup.editor.execCommand('mceRepaint');
  			tinyMCEPopup.editor.focus();
  		} else {
! 			ed.execCommand('mceInsertContent', false, '<img id="__mce_tmp" />', {skip_undo : 1});
! 			ed.dom.setAttribs('__mce_tmp', args);
! 			ed.dom.setAttrib('__mce_tmp', 'id', '');
  			ed.undoManager.add();
  		}
  
--- 90,102 ----
  			tinyMCEPopup.editor.execCommand('mceRepaint');
  			tinyMCEPopup.editor.focus();
  		} else {
! 			tinymce.each(args, function(value, name) {
! 				if (value === "") {
! 					delete args[name];
! 				}
! 			});
! 
! 			ed.execCommand('mceInsertContent', false, tinyMCEPopup.editor.dom.createHTML('img', args), {skip_undo : 1});
  			ed.undoManager.add();
  		}
  
***************
*** 101,131 ****
  	},
  
  	updateStyle : function() {
! 		var dom = tinyMCEPopup.dom, st, v, cls, oldcls, rep, f = document.forms[0];
  
  		if (tinyMCEPopup.editor.settings.inline_styles) {
  			st = tinyMCEPopup.dom.parseStyle(this.styleVal);
  
  			// Handle align
  			v = getSelectValue(f, 'align');
- 			cls = f.class_name.value || '';
- 			cls = cls ? cls.replace(/alignright\s*|alignleft\s*|aligncenter\s*/g, '') : '';
- 			cls = cls ? cls.replace(/^\s*(.+?)\s*$/, '$1') : '';
  			if (v) {
  				if (v == 'left' || v == 'right') {
  					st['float'] = v;
  					delete st['vertical-align'];
- 					oldcls = cls ? ' '+cls : '';
- 					f.class_name.value = 'align' + v + oldcls;
  				} else {
  					st['vertical-align'] = v;
  					delete st['float'];
- 					f.class_name.value = cls;
  				}
  			} else {
  				delete st['float'];
  				delete st['vertical-align'];
- 				f.class_name.value = cls;
  			}
  
  			// Handle border
--- 104,127 ----
  	},
  
  	updateStyle : function() {
! 		var dom = tinyMCEPopup.dom, st, v, f = document.forms[0];
  
  		if (tinyMCEPopup.editor.settings.inline_styles) {
  			st = tinyMCEPopup.dom.parseStyle(this.styleVal);
  
  			// Handle align
  			v = getSelectValue(f, 'align');
  			if (v) {
  				if (v == 'left' || v == 'right') {
  					st['float'] = v;
  					delete st['vertical-align'];
  				} else {
  					st['vertical-align'] = v;
  					delete st['float'];
  				}
  			} else {
  				delete st['float'];
  				delete st['vertical-align'];
  			}
  
  			// Handle border
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/js/tinymce/utils/editable_selects.js ./wordpress-3.3/wp-includes/js/tinymce/utils/editable_selects.js
*** ./wordpress-3.2.1/wp-includes/js/tinymce/utils/editable_selects.js	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/js/tinymce/utils/editable_selects.js	2011-09-09 15:08:40.000000000 -0500
***************
*** 16,22 ****
  
  		for (i=0; i<nl.length; i++) {
  			if (nl[i].className.indexOf('mceEditableSelect') != -1) {
! 				o = new Option('(value)', '__mce_add_custom__');
  
  				o.className = 'mceAddSelectValue';
  
--- 16,22 ----
  
  		for (i=0; i<nl.length; i++) {
  			if (nl[i].className.indexOf('mceEditableSelect') != -1) {
! 				o = new Option(tinyMCEPopup.editor.translate('value'), '__mce_add_custom__');
  
  				o.className = 'mceAddSelectValue';
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/js/tinymce/wp-mce-help.php ./wordpress-3.3/wp-includes/js/tinymce/wp-mce-help.php
*** ./wordpress-3.2.1/wp-includes/js/tinymce/wp-mce-help.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/js/tinymce/wp-mce-help.php	2011-12-08 17:02:33.000000000 -0600
***************
*** 9,25 ****
  require_once('../../../wp-load.php');
  header('Content-Type: text/html; charset=' . get_bloginfo('charset'));
  ?>
! <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
  <head>
  <meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
  <title><?php _e('Rich Editor Help') ?></title>
  <script type="text/javascript" src="tiny_mce_popup.js?ver=342"></script>
  <?php
- wp_admin_css( 'global', true );
  wp_admin_css( 'wp-admin', true );
  ?>
  <style type="text/css">
  	#wphead {
  		font-size: 80%;
  		border-top: 0;
--- 9,27 ----
  require_once('../../../wp-load.php');
  header('Content-Type: text/html; charset=' . get_bloginfo('charset'));
  ?>
! <!DOCTYPE html>
  <html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
  <head>
  <meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
  <title><?php _e('Rich Editor Help') ?></title>
  <script type="text/javascript" src="tiny_mce_popup.js?ver=342"></script>
  <?php
  wp_admin_css( 'wp-admin', true );
  ?>
  <style type="text/css">
+ 	body {
+ 		min-width: 0;
+ 	}
  	#wphead {
  		font-size: 80%;
  		border-top: 0;
***************
*** 36,41 ****
--- 38,44 ----
  		padding: 15px 15px 3px;
  		background-color: #f1f1f1;
  		border-bottom: 1px solid #dfdfdf;
+ 		margin: 0;
  	}
  	#tabs li {
  		display: inline;
***************
*** 140,146 ****
  	.macwebkit tr.mac {
  		display: table-row;
  	}
! 	
  </style>
  <?php if ( is_rtl() ) : ?>
  <style type="text/css">
--- 143,149 ----
  	.macwebkit tr.mac {
  		display: table-row;
  	}
! 
  </style>
  <?php if ( is_rtl() ) : ?>
  <style type="text/css">
***************
*** 178,184 ****
  
  		document.getElementById('version').innerHTML = tinymce.majorVersion + "." + tinymce.minorVersion;
          document.getElementById('date').innerHTML = tinymce.releaseDate;
!  
  		if ( win.fullscreen && win.fullscreen.settings.visible ) {
  			d('content1').className = 'hidden';
  			d('tabs').className = 'hidden';
--- 181,187 ----
  
  		document.getElementById('version').innerHTML = tinymce.majorVersion + "." + tinymce.minorVersion;
          document.getElementById('date').innerHTML = tinymce.releaseDate;
! 
  		if ( win.fullscreen && win.fullscreen.settings.visible ) {
  			d('content1').className = 'hidden';
  			d('tabs').className = 'hidden';
***************
*** 187,193 ****
  
  		if ( tinymce.isMac )
  			document.body.className = 'macos';
! 		
  		if ( tinymce.isMac && tinymce.isWebKit )
  			document.body.className = 'macos macwebkit';
  
--- 190,196 ----
  
  		if ( tinymce.isMac )
  			document.body.className = 'macos';
! 
  		if ( tinymce.isMac && tinymce.isWebKit )
  			document.body.className = 'macos macwebkit';
  
***************
*** 197,206 ****
  <body>
  
  <ul id="tabs">
! 	<li><a id="tab1" href="javascript:flipTab(1)" title="<?php _e('Basics of Rich Editing') ?>" accesskey="1" tabindex="1" class="current"><?php _e('Basics') ?></a></li>
! 	<li><a id="tab2" href="javascript:flipTab(2)" title="<?php _e('Advanced use of the Rich Editor') ?>" accesskey="2" tabindex="2"><?php _e('Advanced') ?></a></li>
! 	<li><a id="tab3" href="javascript:flipTab(3)" title="<?php _e('Hotkeys') ?>" accesskey="3" tabindex="3"><?php _e('Hotkeys') ?></a></li>
! 	<li><a id="tab4" href="javascript:flipTab(4)" title="<?php _e('About the software') ?>" accesskey="4" tabindex="4"><?php _e('About') ?></a></li>
  </ul>
  
  <div id="flipper" class="wrap">
--- 200,209 ----
  <body>
  
  <ul id="tabs">
! 	<li><a id="tab1" href="javascript:flipTab(1)" title="<?php esc_attr_e('Basics of Rich Editing') ?>" accesskey="1" tabindex="1" class="current"><?php _e('Basics') ?></a></li>
! 	<li><a id="tab2" href="javascript:flipTab(2)" title="<?php esc_attr_e('Advanced use of the Rich Editor') ?>" accesskey="2" tabindex="2"><?php _e('Advanced') ?></a></li>
! 	<li><a id="tab3" href="javascript:flipTab(3)" title="<?php esc_attr_e('Hotkeys') ?>" accesskey="3" tabindex="3"><?php _e('Hotkeys') ?></a></li>
! 	<li><a id="tab4" href="javascript:flipTab(4)" title="<?php esc_attr_e('About the software') ?>" accesskey="4" tabindex="4"><?php _e('About') ?></a></li>
  </ul>
  
  <div id="flipper" class="wrap">
***************
*** 273,279 ****
  	<p><?php _e('For more information about this software visit the <a href="http://tinymce.moxiecode.com" target="_blank">TinyMCE website</a>.') ?></p>
  
  	<div id="buttoncontainer">
! 		<a href="http://www.moxiecode.com" target="_blank"><img src="themes/advanced/img/gotmoxie.png" alt="<?php _e('Got Moxie?') ?>" style="border: 0" /></a>
  	</div>
  
  </div>
--- 276,282 ----
  	<p><?php _e('For more information about this software visit the <a href="http://tinymce.moxiecode.com" target="_blank">TinyMCE website</a>.') ?></p>
  
  	<div id="buttoncontainer">
! 		<a href="http://www.moxiecode.com" target="_blank"><img src="themes/advanced/img/gotmoxie.png" alt="<?php esc_attr_e('Got Moxie?') ?>" style="border: 0" /></a>
  	</div>
  
  </div>
***************
*** 281,287 ****
  
  <div class="mceActionPanel">
  	<div style="margin: 8px auto; text-align: center;padding-bottom: 10px;">
! 		<input type="button" id="cancel" name="cancel" value="<?php _e('Close'); ?>" title="<?php _e('Close'); ?>" onclick="tinyMCEPopup.close();" />
  	</div>
  </div>
  
--- 284,290 ----
  
  <div class="mceActionPanel">
  	<div style="margin: 8px auto; text-align: center;padding-bottom: 10px;">
! 		<input type="button" id="cancel" name="cancel" value="<?php esc_attr_e('Close'); ?>" title="<?php esc_attr_e('Close'); ?>" onclick="tinyMCEPopup.close();" />
  	</div>
  </div>
  
Binary files ./wordpress-3.2.1/wp-includes/js/tinymce/wp-tinymce.js.gz and ./wordpress-3.3/wp-includes/js/tinymce/wp-tinymce.js.gz differ
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/js/wplink.dev.js ./wordpress-3.3/wp-includes/js/wplink.dev.js
*** ./wordpress-3.2.1/wp-includes/js/wplink.dev.js	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.3/wp-includes/js/wplink.dev.js	2011-11-28 10:37:46.000000000 -0600
***************
*** 0 ****
--- 1,594 ----
+ var wpLink;
+ 
+ (function($){
+ 	var inputs = {}, rivers = {}, ed, River, Query;
+ 
+ 	wpLink = {
+ 		timeToTriggerRiver: 150,
+ 		minRiverAJAXDuration: 200,
+ 		riverBottomThreshold: 5,
+ 		keySensitivity: 100,
+ 		lastSearch: '',
+ 		textarea: '',
+ 
+ 		init : function() {
+ 			inputs.dialog = $('#wp-link');
+ 			inputs.submit = $('#wp-link-submit');
+ 			// URL
+ 			inputs.url = $('#url-field');
+ 			inputs.nonce = $('#_ajax_linking_nonce');
+ 			// Secondary options
+ 			inputs.title = $('#link-title-field');
+ 			// Advanced Options
+ 			inputs.openInNewTab = $('#link-target-checkbox');
+ 			inputs.search = $('#search-field');
+ 			// Build Rivers
+ 			rivers.search = new River( $('#search-results') );
+ 			rivers.recent = new River( $('#most-recent-results') );
+ 			rivers.elements = $('.query-results', inputs.dialog);
+ 
+ 			// Bind event handlers
+ 			inputs.dialog.keydown( wpLink.keydown );
+ 			inputs.dialog.keyup( wpLink.keyup );
+ 			inputs.submit.click( function(e){
+ 				e.preventDefault();
+ 				wpLink.update();
+ 			});
+ 			$('#wp-link-cancel').click( function(e){
+ 				e.preventDefault();
+ 				wpLink.close();
+ 			});
+ 			$('#internal-toggle').click( wpLink.toggleInternalLinking );
+ 
+ 			rivers.elements.bind('river-select', wpLink.updateFields );
+ 
+ 			inputs.search.keyup( wpLink.searchInternalLinks );
+ 
+ 			inputs.dialog.bind('wpdialogrefresh', wpLink.refresh);
+ 			inputs.dialog.bind('wpdialogbeforeopen', wpLink.beforeOpen);
+ 			inputs.dialog.bind('wpdialogclose', wpLink.onClose);
+ 		},
+ 
+ 		beforeOpen : function() {
+ 			wpLink.range = null;
+ 
+ 			if ( ! wpLink.isMCE() && document.selection ) {
+ 				wpLink.textarea.focus();
+ 				wpLink.range = document.selection.createRange();
+ 			}
+ 		},
+ 
+ 		open : function() {
+ 			if ( !wpActiveEditor )
+ 				return;
+ 
+ 			this.textarea = $('#'+wpActiveEditor).get(0);
+ 
+ 			// Initialize the dialog if necessary (html mode).
+ 			if ( ! inputs.dialog.data('wpdialog') ) {
+ 				inputs.dialog.wpdialog({
+ 					title: wpLinkL10n.title,
+ 					width: 480,
+ 					height: 'auto',
+ 					modal: true,
+ 					dialogClass: 'wp-dialog',
+ 					zIndex: 300000
+ 				});
+ 			}
+ 
+ 			inputs.dialog.wpdialog('open');
+ 		},
+ 
+ 		isMCE : function() {
+ 			return tinyMCEPopup && ( ed = tinyMCEPopup.editor ) && ! ed.isHidden();
+ 		},
+ 
+ 		refresh : function() {
+ 			// Refresh rivers (clear links, check visibility)
+ 			rivers.search.refresh();
+ 			rivers.recent.refresh();
+ 
+ 			if ( wpLink.isMCE() )
+ 				wpLink.mceRefresh();
+ 			else
+ 				wpLink.setDefaultValues();
+ 
+ 			// Focus the URL field and highlight its contents.
+ 			//     If this is moved above the selection changes,
+ 			//     IE will show a flashing cursor over the dialog.
+ 			inputs.url.focus()[0].select();
+ 			// Load the most recent results if this is the first time opening the panel.
+ 			if ( ! rivers.recent.ul.children().length )
+ 				rivers.recent.ajax();
+ 		},
+ 
+ 		mceRefresh : function() {
+ 			var e;
+ 			ed = tinyMCEPopup.editor;
+ 
+ 			tinyMCEPopup.restoreSelection();
+ 
+ 			// If link exists, select proper values.
+ 			if ( e = ed.dom.getParent(ed.selection.getNode(), 'A') ) {
+ 				// Set URL and description.
+ 				inputs.url.val( ed.dom.getAttrib(e, 'href') );
+ 				inputs.title.val( ed.dom.getAttrib(e, 'title') );
+ 				// Set open in new tab.
+ 				if ( "_blank" == ed.dom.getAttrib(e, 'target') )
+ 					inputs.openInNewTab.prop('checked', true);
+ 				// Update save prompt.
+ 				inputs.submit.val( wpLinkL10n.update );
+ 
+ 			// If there's no link, set the default values.
+ 			} else {
+ 				wpLink.setDefaultValues();
+ 			}
+ 
+ 			tinyMCEPopup.storeSelection();
+ 		},
+ 
+ 		close : function() {
+ 			if ( wpLink.isMCE() )
+ 				tinyMCEPopup.close();
+ 			else
+ 				inputs.dialog.wpdialog('close');
+ 		},
+ 
+ 		onClose: function() {
+ 			if ( ! wpLink.isMCE() ) {
+ 				wpLink.textarea.focus();
+ 				if ( wpLink.range ) {
+ 					wpLink.range.moveToBookmark( wpLink.range.getBookmark() );
+ 					wpLink.range.select();
+ 				}
+ 			}
+ 		},
+ 
+ 		getAttrs : function() {
+ 			return {
+ 				href : inputs.url.val(),
+ 				title : inputs.title.val(),
+ 				target : inputs.openInNewTab.prop('checked') ? '_blank' : ''
+ 			};
+ 		},
+ 
+ 		update : function() {
+ 			if ( wpLink.isMCE() )
+ 				wpLink.mceUpdate();
+ 			else
+ 				wpLink.htmlUpdate();
+ 		},
+ 
+ 		htmlUpdate : function() {
+ 			var attrs, html, start, end, cursor,
+ 				textarea = wpLink.textarea;
+ 
+ 			if ( ! textarea )
+ 				return;
+ 
+ 			attrs = wpLink.getAttrs();
+ 
+ 			// If there's no href, return.
+ 			if ( ! attrs.href || attrs.href == 'http://' )
+ 				return;
+ 
+ 			// Build HTML
+ 			html = '<a href="' + attrs.href + '"';
+ 
+ 			if ( attrs.title )
+ 				html += ' title="' + attrs.title + '"';
+ 			if ( attrs.target )
+ 				html += ' target="' + attrs.target + '"';
+ 
+ 			html += '>';
+ 
+ 			// Insert HTML
+ 			// W3C
+ 			if ( typeof textarea.selectionStart !== 'undefined' ) {
+ 				start       = textarea.selectionStart;
+ 				end         = textarea.selectionEnd;
+ 				selection   = textarea.value.substring( start, end );
+ 				html        = html + selection + '</a>';
+ 				cursor      = start + html.length;
+ 
+ 				// If no next is selected, place the cursor inside the closing tag.
+ 				if ( start == end )
+ 					cursor -= '</a>'.length;
+ 
+ 				textarea.value = textarea.value.substring( 0, start )
+ 				               + html
+ 				               + textarea.value.substring( end, textarea.value.length );
+ 
+ 				// Update cursor position
+ 				textarea.selectionStart = textarea.selectionEnd = cursor;
+ 
+ 			// IE
+ 			// Note: If no text is selected, IE will not place the cursor
+ 			//       inside the closing tag.
+ 			} else if ( document.selection && wpLink.range ) {
+ 				textarea.focus();
+ 				wpLink.range.text = html + wpLink.range.text + '</a>';
+ 				wpLink.range.moveToBookmark( wpLink.range.getBookmark() );
+ 				wpLink.range.select();
+ 
+ 				wpLink.range = null;
+ 			}
+ 
+ 			wpLink.close();
+ 			textarea.focus();
+ 		},
+ 
+ 		mceUpdate : function() {
+ 			var ed = tinyMCEPopup.editor,
+ 				attrs = wpLink.getAttrs(),
+ 				e, b;
+ 
+ 			tinyMCEPopup.restoreSelection();
+ 			e = ed.dom.getParent(ed.selection.getNode(), 'A');
+ 
+ 			// If the values are empty, unlink and return
+ 			if ( ! attrs.href || attrs.href == 'http://' ) {
+ 				if ( e ) {
+ 					tinyMCEPopup.execCommand("mceBeginUndoLevel");
+ 					b = ed.selection.getBookmark();
+ 					ed.dom.remove(e, 1);
+ 					ed.selection.moveToBookmark(b);
+ 					tinyMCEPopup.execCommand("mceEndUndoLevel");
+ 					wpLink.close();
+ 				}
+ 				return;
+ 			}
+ 
+ 			tinyMCEPopup.execCommand("mceBeginUndoLevel");
+ 
+ 			if (e == null) {
+ 				ed.getDoc().execCommand("unlink", false, null);
+ 				tinyMCEPopup.execCommand("CreateLink", false, "#mce_temp_url#", {skip_undo : 1});
+ 
+ 				tinymce.each(ed.dom.select("a"), function(n) {
+ 					if (ed.dom.getAttrib(n, 'href') == '#mce_temp_url#') {
+ 						e = n;
+ 						ed.dom.setAttribs(e, attrs);
+ 					}
+ 				});
+ 
+ 				// Sometimes WebKit lets a user create a link where
+ 				// they shouldn't be able to. In this case, CreateLink
+ 				// injects "#mce_temp_url#" into their content. Fix it.
+ 				if ( $(e).text() == '#mce_temp_url#' ) {
+ 					ed.dom.remove(e);
+ 					e = null;
+ 				}
+ 			} else {
+ 				ed.dom.setAttribs(e, attrs);
+ 			}
+ 
+ 			// Don't move caret if selection was image
+ 			if ( e && (e.childNodes.length != 1 || e.firstChild.nodeName != 'IMG') ) {
+ 				ed.focus();
+ 				ed.selection.select(e);
+ 				ed.selection.collapse(0);
+ 				tinyMCEPopup.storeSelection();
+ 			}
+ 
+ 			tinyMCEPopup.execCommand("mceEndUndoLevel");
+ 			wpLink.close();
+ 		},
+ 
+ 		updateFields : function( e, li, originalEvent ) {
+ 			inputs.url.val( li.children('.item-permalink').val() );
+ 			inputs.title.val( li.hasClass('no-title') ? '' : li.children('.item-title').text() );
+ 			if ( originalEvent && originalEvent.type == "click" )
+ 				inputs.url.focus();
+ 		},
+ 		setDefaultValues : function() {
+ 			// Set URL and description to defaults.
+ 			// Leave the new tab setting as-is.
+ 			inputs.url.val('http://');
+ 			inputs.title.val('');
+ 
+ 			// Update save prompt.
+ 			inputs.submit.val( wpLinkL10n.save );
+ 		},
+ 
+ 		searchInternalLinks : function() {
+ 			var t = $(this), waiting,
+ 				search = t.val();
+ 
+ 			if ( search.length > 2 ) {
+ 				rivers.recent.hide();
+ 				rivers.search.show();
+ 
+ 				// Don't search if the keypress didn't change the title.
+ 				if ( wpLink.lastSearch == search )
+ 					return;
+ 
+ 				wpLink.lastSearch = search;
+ 				waiting = t.siblings('img.waiting').show();
+ 
+ 				rivers.search.change( search );
+ 				rivers.search.ajax( function(){ waiting.hide(); });
+ 			} else {
+ 				rivers.search.hide();
+ 				rivers.recent.show();
+ 			}
+ 		},
+ 
+ 		next : function() {
+ 			rivers.search.next();
+ 			rivers.recent.next();
+ 		},
+ 		prev : function() {
+ 			rivers.search.prev();
+ 			rivers.recent.prev();
+ 		},
+ 
+ 		keydown : function( event ) {
+ 			var fn, key = $.ui.keyCode;
+ 
+ 			switch( event.which ) {
+ 				case key.UP:
+ 					fn = 'prev';
+ 				case key.DOWN:
+ 					fn = fn || 'next';
+ 					clearInterval( wpLink.keyInterval );
+ 					wpLink[ fn ]();
+ 					wpLink.keyInterval = setInterval( wpLink[ fn ], wpLink.keySensitivity );
+ 					break;
+ 				default:
+ 					return;
+ 			}
+ 			event.preventDefault();
+ 		},
+ 		keyup: function( event ) {
+ 			var key = $.ui.keyCode;
+ 
+ 			switch( event.which ) {
+ 				case key.ESCAPE:
+ 					event.stopImmediatePropagation();
+ 					if ( ! $(document).triggerHandler( 'wp_CloseOnEscape', [{ event: event, what: 'wplink', cb: wpLink.close }] ) )
+ 						wpLink.close();
+ 
+ 					return false;
+ 					break;
+ 				case key.UP:
+ 				case key.DOWN:
+ 					clearInterval( wpLink.keyInterval );
+ 					break;
+ 				default:
+ 					return;
+ 			}
+ 			event.preventDefault();
+ 		},
+ 
+ 		delayedCallback : function( func, delay ) {
+ 			var timeoutTriggered, funcTriggered, funcArgs, funcContext;
+ 
+ 			if ( ! delay )
+ 				return func;
+ 
+ 			setTimeout( function() {
+ 				if ( funcTriggered )
+ 					return func.apply( funcContext, funcArgs );
+ 				// Otherwise, wait.
+ 				timeoutTriggered = true;
+ 			}, delay);
+ 
+ 			return function() {
+ 				if ( timeoutTriggered )
+ 					return func.apply( this, arguments );
+ 				// Otherwise, wait.
+ 				funcArgs = arguments;
+ 				funcContext = this;
+ 				funcTriggered = true;
+ 			};
+ 		},
+ 
+ 		toggleInternalLinking : function( event ) {
+ 			var panel = $('#search-panel'),
+ 				widget = inputs.dialog.wpdialog('widget'),
+ 				// We're about to toggle visibility; it's currently the opposite
+ 				visible = !panel.is(':visible'),
+ 				win = $(window);
+ 
+ 			$(this).toggleClass('toggle-arrow-active', visible);
+ 
+ 			inputs.dialog.height('auto');
+ 			panel.slideToggle( 300, function() {
+ 				setUserSetting('wplink', visible ? '1' : '0');
+ 				inputs[ visible ? 'search' : 'url' ].focus();
+ 
+ 				// Move the box if the box is now expanded, was opened in a collapsed state,
+ 				// and if it needs to be moved. (Judged by bottom not being positive or
+ 				// bottom being smaller than top.)
+ 				var scroll = win.scrollTop(),
+ 					top = widget.offset().top,
+ 					bottom = top + widget.outerHeight(),
+ 					diff = bottom - win.height();
+ 
+ 				if ( diff > scroll ) {
+ 					widget.animate({'top': diff < top ?  top - diff : scroll }, 200);
+ 				}
+ 			});
+ 			event.preventDefault();
+ 		}
+ 	}
+ 
+ 	River = function( element, search ) {
+ 		var self = this;
+ 		this.element = element;
+ 		this.ul = element.children('ul');
+ 		this.waiting = element.find('.river-waiting');
+ 
+ 		this.change( search );
+ 		this.refresh();
+ 
+ 		element.scroll( function(){ self.maybeLoad(); });
+ 		element.delegate('li', 'click', function(e){ self.select( $(this), e ); });
+ 	};
+ 
+ 	$.extend( River.prototype, {
+ 		refresh: function() {
+ 			this.deselect();
+ 			this.visible = this.element.is(':visible');
+ 		},
+ 		show: function() {
+ 			if ( ! this.visible ) {
+ 				this.deselect();
+ 				this.element.show();
+ 				this.visible = true;
+ 			}
+ 		},
+ 		hide: function() {
+ 			this.element.hide();
+ 			this.visible = false;
+ 		},
+ 		// Selects a list item and triggers the river-select event.
+ 		select: function( li, event ) {
+ 			var liHeight, elHeight, liTop, elTop;
+ 
+ 			if ( li.hasClass('unselectable') || li == this.selected )
+ 				return;
+ 
+ 			this.deselect();
+ 			this.selected = li.addClass('selected');
+ 			// Make sure the element is visible
+ 			liHeight = li.outerHeight();
+ 			elHeight = this.element.height();
+ 			liTop = li.position().top;
+ 			elTop = this.element.scrollTop();
+ 
+ 			if ( liTop < 0 ) // Make first visible element
+ 				this.element.scrollTop( elTop + liTop );
+ 			else if ( liTop + liHeight > elHeight ) // Make last visible element
+ 				this.element.scrollTop( elTop + liTop - elHeight + liHeight );
+ 
+ 			// Trigger the river-select event
+ 			this.element.trigger('river-select', [ li, event, this ]);
+ 		},
+ 		deselect: function() {
+ 			if ( this.selected )
+ 				this.selected.removeClass('selected');
+ 			this.selected = false;
+ 		},
+ 		prev: function() {
+ 			if ( ! this.visible )
+ 				return;
+ 
+ 			var to;
+ 			if ( this.selected ) {
+ 				to = this.selected.prev('li');
+ 				if ( to.length )
+ 					this.select( to );
+ 			}
+ 		},
+ 		next: function() {
+ 			if ( ! this.visible )
+ 				return;
+ 
+ 			var to = this.selected ? this.selected.next('li') : $('li:not(.unselectable):first', this.element);
+ 			if ( to.length )
+ 				this.select( to );
+ 		},
+ 		ajax: function( callback ) {
+ 			var self = this,
+ 				delay = this.query.page == 1 ? 0 : wpLink.minRiverAJAXDuration,
+ 				response = wpLink.delayedCallback( function( results, params ) {
+ 					self.process( results, params );
+ 					if ( callback )
+ 						callback( results, params );
+ 				}, delay );
+ 
+ 			this.query.ajax( response );
+ 		},
+ 		change: function( search ) {
+ 			if ( this.query && this._search == search )
+ 				return;
+ 
+ 			this._search = search;
+ 			this.query = new Query( search );
+ 			this.element.scrollTop(0);
+ 		},
+ 		process: function( results, params ) {
+ 			var list = '', alt = true, classes = '',
+ 				firstPage = params.page == 1;
+ 
+ 			if ( !results ) {
+ 				if ( firstPage ) {
+ 					list += '<li class="unselectable"><span class="item-title"><em>'
+ 					+ wpLinkL10n.noMatchesFound
+ 					+ '</em></span></li>';
+ 				}
+ 			} else {
+ 				$.each( results, function() {
+ 					classes = alt ? 'alternate' : '';
+ 					classes += this['title'] ? '' : ' no-title';
+ 					list += classes ? '<li class="' + classes + '">' : '<li>';
+ 					list += '<input type="hidden" class="item-permalink" value="' + this['permalink'] + '" />';
+ 					list += '<span class="item-title">';
+ 					list += this['title'] ? this['title'] : wpLinkL10n.noTitle;
+ 					list += '</span><span class="item-info">' + this['info'] + '</span></li>';
+ 					alt = ! alt;
+ 				});
+ 			}
+ 
+ 			this.ul[ firstPage ? 'html' : 'append' ]( list );
+ 		},
+ 		maybeLoad: function() {
+ 			var self = this,
+ 				el = this.element,
+ 				bottom = el.scrollTop() + el.height();
+ 
+ 			if ( ! this.query.ready() || bottom < this.ul.height() - wpLink.riverBottomThreshold )
+ 				return;
+ 
+ 			setTimeout(function() {
+ 				var newTop = el.scrollTop(),
+ 					newBottom = newTop + el.height();
+ 
+ 				if ( ! self.query.ready() || newBottom < self.ul.height() - wpLink.riverBottomThreshold )
+ 					return;
+ 
+ 				self.waiting.show();
+ 				el.scrollTop( newTop + self.waiting.outerHeight() );
+ 
+ 				self.ajax( function() { self.waiting.hide(); });
+ 			}, wpLink.timeToTriggerRiver );
+ 		}
+ 	});
+ 
+ 	Query = function( search ) {
+ 		this.page = 1;
+ 		this.allLoaded = false;
+ 		this.querying = false;
+ 		this.search = search;
+ 	};
+ 
+ 	$.extend( Query.prototype, {
+ 		ready: function() {
+ 			return !( this.querying || this.allLoaded );
+ 		},
+ 		ajax: function( callback ) {
+ 			var self = this,
+ 				query = {
+ 					action : 'wp-link-ajax',
+ 					page : this.page,
+ 					'_ajax_linking_nonce' : inputs.nonce.val()
+ 				};
+ 
+ 			if ( this.search )
+ 				query.search = this.search;
+ 
+ 			this.querying = true;
+ 
+ 			$.post( ajaxurl, query, function(r) {
+ 				self.page++;
+ 				self.querying = false;
+ 				self.allLoaded = !r;
+ 				callback( r, query );
+ 			}, "json" );
+ 		}
+ 	});
+ 
+ 	$(document).ready( wpLink.init );
+ })(jQuery);
